<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4">

  <app-breadcrumbs></app-breadcrumbs>

  <div
    id="tenantListTitle"
    class="h3"
    [innerText]="messages.TENANT_MANAGEMENT">
  </div>

  <!-- Header -->

  <div class="mt-3 mb-2 d-flex align-items-start">

    <button
      ls-button
      [icon]="commonIcons.CREATE_ICON"
      [text]="messages.CREATE_TENANT"
      (click)="onCreateButtonClicked()">
    </button>

    <app-search-bar
      class="ms-2"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="messages.SEARCH_TENANTS">
    </app-search-bar>

    <span class="flex-grow-1"></span>
    <span class="p-1 px-2" [innerText]="commonMessages.PAGINATION_SIZE_LABEL"></span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="refreshTenantList(true)">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="tenantListTitle"
    class="bg-white table table-fixed table-striped table-borderless border shadow-sm table-text-overflow">
    <thead class="border">
      <tr>
        <th
          *ngIf="userPreferences.showAdminIds"
          scope="col"
          class="th-sm col-id-fixed-size"
          (click)="onRowOrderClicked(sortByEnum.Id)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Id ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUpIcon : caretDownIcon"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.ID }}
        </th>
        <th
          class="th-sm"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.Name)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Name ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUpIcon : caretDownIcon"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.NAME }}
        </th>
        <th
          scope="col"
          class="th-sm col-buttons-fixed-size"
          [innerText]="commonMessages.ACTIONS">
        </th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let tenant of tenantList">
        <td *ngIf="userPreferences.showAdminIds">
          <span
            class="sortable-row font-monospace text-size-small"
            [innerText]="tenant.id | namePipe">
          </span>
        </td>
        <td>
          <span
            class="sortable-row"
            [innerText]="tenant.name | namePipe ">
          </span>
        </td>
        <td>
          <button
            type="button"
            class="btn btn-sm btn-outline-primary"
            [title]="commonMessages.EDIT"
            (click)="onEditButtonClicked(tenant)">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>
          <button
            type="button"
            class="btn btn-sm btn-outline-danger ms-2"
            [title]="commonMessages.DELETE"
            (click)="onDeleteButtonClicked(tenant)">
            <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="tenantList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_TENANT_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="refreshTenantList(false)">
  </ngb-pagination>

</div>

